/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.benutzerverwaltung.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="ROLLE.UK",
     query="SELECT o FROM Rolle o WHERE "

                         + "o"
                +".name"
              +" = ?1"

             +" AND "         + "o"
                +".mandant"
                +".nummer"
              +" = ?2"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="ROLLE.All",
     query="SELECT OBJECT(o) FROM Rolle o WHERE o.mandant = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ROLLE.BenutzerEinsatzort",
     query="SELECT o FROM Rolle o, BenutzerEinsatzort b WHERE o MEMBER OF b.rolles AND b=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ROLLE.Benutzer",
     query="SELECT o FROM Rolle o, Benutzer b WHERE o MEMBER OF b.rolles AND b=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ROLLE.GebietRolle",
     query="SELECT o FROM Rolle o WHERE (SELECT COUNT(g) FROM Gebiet g WHERE g.einsehenRolle = o)>0 OR (SELECT COUNT(g) FROM Gebiet g WHERE g.bearbeitenRolle = o)>0 AND o.mandant = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ROLLE.Name",
     query="SELECT OBJECT(o) FROM Rolle o WHERE o.mandant = ?1 AND o.name=?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ROLLE.WahlRolle",
     query="SELECT o FROM Rolle o WHERE (SELECT COUNT(w) FROM Wahl w WHERE w.einsehenRolle = o)>0 OR (SELECT COUNT(w) FROM Wahltermin w WHERE w.einsehenRolle = o)>0 AND o.mandant=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "ROLLE")
// @javax.persistence.IdClass(RollePK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Rolle
extends AbstractRolle
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Rolle() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Rolle(Rolle original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "rolle_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Rolle")
    @javax.persistence.TableGenerator(name = "Rolle", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Rolle", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient RollePK pkCache;

  @Override
  public RollePK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new RollePK(getId());
    }

    return pkCache;
  }

  public static <E extends Rolle> java.util.Map<RollePK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<RollePK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Rolle> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedBeschreibung = false;
          hasChangedName = false;
  
      hasChangedMandant = false;
  
          hasChangedBenutzerEinsatzorts = false;
                  hasChangedNachrichts = false;
      
                                  
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "BESCHREIBUNG", nullable = RolleConstants.BESCHREIBUNG_NULLABLE, length=RolleConstants.BESCHREIBUNG_MAX_LENGTH)
        
  protected java.lang.String beschreibung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBeschreibung = false;

  public boolean hasChangedBeschreibung(){
    return hasChangedBeschreibung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBeschreibung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBeschreibung;
  
  /**
   * 
   *
   * getter for ROLLE.BESCHREIBUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBeschreibung() {
        return beschreibung;
      }

  /**
   * 
   *
   * setter for ROLLE.BESCHREIBUNG
   *
   * @param beschreibung
   */
  @Override   public void setBeschreibung(@javax.annotation.Nullable  java.lang.String beschreibung) {

       resetTkCache();
                  
                          java.lang.String beschreibungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(beschreibung, RolleConstants.BESCHREIBUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.beschreibung
      , beschreibungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBeschreibung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("beschreibung");
      }


             if (!isSeitLadenVeraendertBeschreibung) {
          isSeitLadenVeraendertBeschreibung = thisAttributChanged;
         if (isSeitLadenVeraendertBeschreibung){
           wertNachLadenBeschreibung=this.beschreibung;
         }
       }
      

       this.beschreibung = beschreibungInternal;

         }

        
      @javax.persistence.Column(name = "NAME", nullable = RolleConstants.NAME_NULLABLE, length=RolleConstants.NAME_MAX_LENGTH)
        
  protected String name =  null;

  @javax.persistence.Transient
  protected boolean hasChangedName = false;

  public boolean hasChangedName(){
    return hasChangedName;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertName = false;
     @javax.persistence.Transient
     private transient String wertNachLadenName;
  
  /**
   * 
   *
   * getter for ROLLE.NAME
   */
    @Override   public  String getName() {
        return name;
      }

  /**
   * 
   *
   * setter for ROLLE.NAME
   *
   * @param name
   */
  @Override   public void setName( String name) {

       resetTkCache();
                  
                          String nameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(name, RolleConstants.NAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.name
      , nameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedName |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("name");
      }


             if (!isSeitLadenVeraendertName) {
          isSeitLadenVeraendertName = thisAttributChanged;
         if (isSeitLadenVeraendertName){
           wertNachLadenName=this.name;
         }
       }
      

       this.name = nameInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Mandant
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "MANDANT_ID", referencedColumnName="MANDANT_ID"))
  protected de.ivu.elect.business.mandant.entity.Mandant mandant;

  /**
   * 
   */
  @Override
  public void setMandant( de.ivu.elect.business.mandant.entity.Mandant mandant){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.mandant
    , mandant);

    attributeChanged |= thisAttributChanged;

    hasChangedMandant |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("mandant");
    }

    this.mandant = mandant;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.mandant.entity.Mandant getMandant(){
    return this.mandant;
  }

  @javax.persistence.Transient
  protected boolean hasChangedMandant = false;

  public boolean hasChangedMandant(){
    return hasChangedMandant;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */
    
   @javax.persistence.ElementCollection(targetClass = String.class)
   @javax.persistence.CollectionTable(name = "RECHT", joinColumns = { @javax.persistence.JoinColumn(name = "ROLLE_ID", referencedColumnName = "ROLLE_ID") })
   @javax.persistence.Column(name = "RECHT")
   protected java.util.Set<String> recht = new java.util.HashSet<>();

   @Override
   public java.util.Set<String> getRechtAsString(){
      return java.util.Collections.unmodifiableSet(this.recht);
   }

   /**
   * Entfernen von allen String
   */
   @Override
   public void removeAllRechtAsStrings(){
      this.recht.clear();
   }

   /**
   * Entfernen von String
   */
   @Override
   public void removeRechtAsString(String value){
      this.recht.remove(value);
   }

   /**
   * Hinzufuegen von String
   */
   @Override
   public void addRechtAsString(String value){
      this.recht.add(value);
   }

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */
  /**
   * Beziehung N:M (bidirektional, nicht-fuehrend) zu BenutzerEinsatzorts
   */
  @javax.persistence.ManyToMany(mappedBy = "rolles", fetch=javax.persistence.FetchType.LAZY)
// elect deaktiviert, gibt Probleme beim Löschen   @org.hibernate.annotations.Cache(usage = org.hibernate.annotations.CacheConcurrencyStrategy.TRANSACTIONAL)
  protected java.util.Set<de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort> benutzerEinsatzorts;

  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  @Override
  public java.util.Set<de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort> getBenutzerEinsatzorts(){
    if (benutzerEinsatzorts == null){
      return  java.util.Collections.<de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort>emptySet());
    }
    return java.util.Collections.<de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort>unmodifiableSet(this.benutzerEinsatzorts);
  }


  @javax.persistence.Transient
  private boolean hasChangedBenutzerEinsatzorts = false;

  public boolean hasChangedBenutzerEinsatzorts() {
    return hasChangedBenutzerEinsatzorts;
  }


 /**
  * Hinzufuegen von de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort
  */
  @Override
  public void addBenutzerEinsatzort(de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort benutzerEinsatzort){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (benutzerEinsatzort != null){
          if (this.benutzerEinsatzorts == null){
            this.benutzerEinsatzorts = new java.util.HashSet<>();
          }

          boolean isChanged = this.benutzerEinsatzorts.add(benutzerEinsatzort);

          if(!hasChangedBenutzerEinsatzorts) {
            hasChangedBenutzerEinsatzorts =  isChanged;
          }

              // andere Seite der Beziehung aktualisieren
          benutzerEinsatzort.addRolle(this);
                  }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort
   */
  @Override
  public void removeBenutzerEinsatzort(de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort benutzerEinsatzort){
    try {
      if (!updateRelationship){
        updateRelationship = true;
        if (benutzerEinsatzort != null){
          if (this.benutzerEinsatzorts != null){
            boolean isChanged = this.benutzerEinsatzorts.remove(benutzerEinsatzort);

            if(!hasChangedBenutzerEinsatzorts) {
              hasChangedBenutzerEinsatzorts =  isChanged;
            }
          }

                    // andere Seite der Beziehung aktualisieren
          if (benutzerEinsatzort != null) {
            benutzerEinsatzort.removeRolle(this);
          }
                  }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen  de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort
  */
   @Override
   public void removeAllBenutzerEinsatzorts(){
     java.util.Set<de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort> toRemove = new java.util.HashSet<>(getBenutzerEinsatzorts());

     for (   de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort entity:toRemove){
       removeBenutzerEinsatzort(entity);
     }
   }
  /**
   * Beziehung N:M (bidirektional, nicht-fuehrend) zu Nachrichts
   */
  @javax.persistence.ManyToMany(mappedBy = "rolles", fetch=javax.persistence.FetchType.LAZY)
// elect deaktiviert, gibt Probleme beim Löschen   @org.hibernate.annotations.Cache(usage = org.hibernate.annotations.CacheConcurrencyStrategy.TRANSACTIONAL)
  protected java.util.Set<de.ivu.elect.business.benutzerverwaltung.entity.Nachricht> nachrichts;

  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  @Override
  public java.util.Set<de.ivu.elect.business.benutzerverwaltung.entity.Nachricht> getNachrichts(){
    if (nachrichts == null){
      return  java.util.Collections.<de.ivu.elect.business.benutzerverwaltung.entity.Nachricht>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.benutzerverwaltung.entity.Nachricht>emptySet());
    }
    return java.util.Collections.<de.ivu.elect.business.benutzerverwaltung.entity.Nachricht>unmodifiableSet(this.nachrichts);
  }


  @javax.persistence.Transient
  private boolean hasChangedNachrichts = false;

  public boolean hasChangedNachrichts() {
    return hasChangedNachrichts;
  }


 /**
  * Hinzufuegen von de.ivu.elect.business.benutzerverwaltung.entity.Nachricht
  */
  @Override
  public void addNachricht(de.ivu.elect.business.benutzerverwaltung.entity.Nachricht nachricht){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (nachricht != null){
          if (this.nachrichts == null){
            this.nachrichts = new java.util.HashSet<>();
          }

          boolean isChanged = this.nachrichts.add(nachricht);

          if(!hasChangedNachrichts) {
            hasChangedNachrichts =  isChanged;
          }

              // andere Seite der Beziehung aktualisieren
          nachricht.addRolle(this);
                  }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.benutzerverwaltung.entity.Nachricht
   */
  @Override
  public void removeNachricht(de.ivu.elect.business.benutzerverwaltung.entity.Nachricht nachricht){
    try {
      if (!updateRelationship){
        updateRelationship = true;
        if (nachricht != null){
          if (this.nachrichts != null){
            boolean isChanged = this.nachrichts.remove(nachricht);

            if(!hasChangedNachrichts) {
              hasChangedNachrichts =  isChanged;
            }
          }

                    // andere Seite der Beziehung aktualisieren
          if (nachricht != null) {
            nachricht.removeRolle(this);
          }
                  }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen  de.ivu.elect.business.benutzerverwaltung.entity.Nachricht
  */
   @Override
   public void removeAllNachrichts(){
     java.util.Set<de.ivu.elect.business.benutzerverwaltung.entity.Nachricht> toRemove = new java.util.HashSet<>(getNachrichts());

     for (   de.ivu.elect.business.benutzerverwaltung.entity.Nachricht entity:toRemove){
       removeNachricht(entity);
     }
   }


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Rolle:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Rolle other){
                             other.beschreibung = this.beschreibung;
                                other.name = this.name;
           
  other.setMandant(this.getMandant());


  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Rolle.class)){
        copyEntityAttributesUsingSetter((Rolle) other.castTo(Rolle.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Rolle: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Rolle other){
               other.setBeschreibung(this.beschreibung);
                  other.setName(this.name);
       
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Rolle other){
                       if (hasChangedBeschreibung) {
        other.setBeschreibung(this.beschreibung);
      }
                             if (hasChangedName) {
        other.setName(this.name);
      }
             }





    @javax.persistence.Transient
    private transient RolleTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public RolleTK getRolleTK(){
    if (tkCache==null) {
    tkCache = new RolleTK(

getName()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getRolleTK();
    }

  @Override
  public RolleUK getUk(){
    return getRolleUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Rolle.class;
  }

public RolleUK getRolleUK(){

   return  new RolleUK(

getName()
,     getMandant()==null?null:getMandant().getMandantUK()


  );
}

  @javax.persistence.Transient
  private transient RolleProperties properties;

  public RolleProperties getProperties(){
    if (properties == null) {
      properties = new RolleProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public RolleProperties getRolleProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return RolleConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(RolleConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(RolleConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL);

        beschreibung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(RolleConstants.MESSAGE_KEY_NAME_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(RolleConstants.MESSAGE_KEY_NAME_EINZAHL);

        name =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertBeschreibung) {
      result.put(RolleConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBeschreibung , beschreibung));
    }
                            if (isSeitLadenVeraendertName) {
      result.put(RolleConstants.MESSAGE_KEY_NAME_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenName , name));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertBeschreibung = false;
      wertNachLadenBeschreibung = null;
                          isSeitLadenVeraendertName = false;
      wertNachLadenName = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "ROLLE";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Rolle";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(RolleConstants.BESCHREIBUNG_MAX_LENGTH ,  beschreibung, this, RolleConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(name, this, RolleConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(RolleConstants.NAME_MAX_LENGTH , 1 ,  name, this, RolleConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        private transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
